tokens SYM_EOF SYM_IDENTIFIER<string> SYM_INTEGER<int> SYM_CHARACTER<char> 
tokens SYM_PLUS SYM_MINUS SYM_ASTERISK SYM_DIV SYM_MOD
tokens SYM_LPARENTHESIS SYM_RPARENTHESIS SYM_LBRACE SYM_RBRACE
tokens SYM_ASSIGN SYM_SEMICOLON SYM_RETURN SYM_IF SYM_WHILE SYM_ELSE SYM_COMMA SYM_PRINT
tokens SYM_EQUALITY SYM_NOTEQ SYM_LT SYM_LEQ SYM_GT SYM_GEQ
tokens SYM_INT SYM_VOID SYM_CHAR  SYM_AMPERSAND
non-terminals S INSTR LINSTRS ELSE EXPR FACTOR
non-terminals LPARAMS REST_PARAMS
non-terminals FUNDEF FUNDEFS REC_NO_REC
non-terminals ADD_EXPRS ADD_EXPR
non-terminals MUL_EXPRS MUL_EXPR
non-terminals CMP_EXPRS CMP_EXPR
non-terminals EQ_EXPRS EQ_EXPR
non-terminals BLOC
non-terminals ASSIGN_OR_FUN VAR_OR_FUN
non-terminals LEXPRS REST_LEXPRS 
non-terminals TYPE DEFINITION_OR_EXPR
non-terminals POINTER_NO REF_POINT_NO

axiom S
{

  open Symbols
  open Ast
  open BatPrintf
  open BatBuffer
  open Batteries
  open Utils

  (* TODO *)
  let resolve_associativity term other =
       (* TODO *)
    List.fold_left (fun acc e -> match e with 
                                  |Node(x,y) -> Node(x,acc::y) 
                                  |_ ->e)
                    term other


}

rules

S -> FUNDEFS SYM_EOF {  Node (Tlistglobdef, $1) }

FUNDEFS -> FUNDEF FUNDEFS {  Node(Tfundef,$1)::$2  }
FUNDEFS -> {  []  }

FUNDEF -> TYPE SYM_IDENTIFIER SYM_LPARENTHESIS LPARAMS SYM_RPARENTHESIS REC_NO_REC {  [Node(Tfunname,[$1 (StringLeaf($2))]);Node(Tfunargs,$4);Node(Tfunbody,$6)]  }
REC_NO_REC -> BLOC {  $1  }
REC_NO_REC -> SYM_SEMICOLON {  []  }
LPARAMS -> TYPE SYM_IDENTIFIER REST_PARAMS {  Node(Targ,[$1 (StringLeaf($2))])::$3  }
LPARAMS -> {  []  }

TYPE -> SYM_INT POINTER_NO {  fun x -> $2 (Node(Tint,[x]))  }
TYPE -> SYM_CHAR POINTER_NO  {  fun x -> Node(Tchar,[x])  }
TYPE -> SYM_VOID POINTER_NO {  fun x -> Node(Tvoid,[x])  }

POINTER_NO -> SYM_ASTERISK POINTER_NO {  fun x -> $2 (Node(Tptr,[x]))}
POINTER_NO -> {fun x -> x}

REST_PARAMS -> SYM_COMMA TYPE SYM_IDENTIFIER REST_PARAMS {  Node(Targ,[$2 (StringLeaf($3))]) :: $4  }
REST_PARAMS -> {  []  }

INSTR -> SYM_IF SYM_LPARENTHESIS EXPR SYM_RPARENTHESIS BLOC ELSE {  [Node(Tif,[$3] @ $5 @ $6)]  }
INSTR -> SYM_WHILE SYM_LPARENTHESIS EXPR SYM_RPARENTHESIS INSTR {  [Node(Twhile,[$3] @ $5)]  }
INSTR -> SYM_RETURN EXPR SYM_SEMICOLON {  [Node(Treturn,[$2])]  }
INSTR -> SYM_PRINT EXPR SYM_SEMICOLON {  [Node(Tprint,[$2])]  }
INSTR -> POINTER_NO SYM_IDENTIFIER ASSIGN_OR_FUN  { $3 ($1 (StringLeaf($2)))  }
INSTR -> TYPE SYM_IDENTIFIER DEFINITION_OR_EXPR {  $3 ($1 (StringLeaf($2)))  }

DEFINITION_OR_EXPR -> SYM_ASSIGN EXPR SYM_SEMICOLON {  fun x -> [Node(Tassign,[Node(Tassignvar,[x;$2])])]  }
DEFINITION_OR_EXPR -> SYM_SEMICOLON {  fun x -> [Node(Tassign,[Node(Tassignvar,[x])])]  }

ASSIGN_OR_FUN -> SYM_ASSIGN EXPR SYM_SEMICOLON { fun x -> [Node(Tassign,[Node(Tassignvar,[x;$2])])]  }
ASSIGN_OR_FUN -> SYM_LPARENTHESIS LEXPRS SYM_RPARENTHESIS SYM_SEMICOLON {  fun x -> [Node(Tcall,[Node(Tfunname,[x]);Node(Targs,$2)])]  }

INSTR -> BLOC {  $1  }
BLOC -> SYM_LBRACE LINSTRS SYM_RBRACE {  [Node(Tblock,$2)]  }

LINSTRS -> INSTR LINSTRS {  $1 @ $2  } 
LINSTRS -> {  []  }

ELSE -> SYM_ELSE BLOC {  $2  }
ELSE -> {  [Node(Tblock,[])]  }

LEXPRS-> EXPR REST_LEXPRS {  $1  ::  $2  }
LEXPRS->{  []  }

REST_LEXPRS -> SYM_COMMA EXPR REST_LEXPRS {   $2  ::  $3 }
REST_LEXPRS -> {  []  }

EXPR -> EQ_EXPR EQ_EXPRS {  resolve_associativity $1 $2  }
EQ_EXPR -> CMP_EXPR CMP_EXPRS {  resolve_associativity $1 $2  }
CMP_EXPR-> ADD_EXPR ADD_EXPRS {  resolve_associativity $1 $2  }
ADD_EXPR -> MUL_EXPR MUL_EXPRS {  resolve_associativity $1 $2  }
ADD_EXPR -> SYM_MINUS MUL_EXPR MUL_EXPRS {  resolve_associativity (Node(Tneg,[$2])) $3  }
MUL_EXPR -> FACTOR {  $1  }

FACTOR -> SYM_INTEGER  {  Node(Tint,[IntLeaf($1)])  }
FACTOR -> SYM_CHARACTER  {  Node(Tchar,[CharLeaf($1)])  }
FACTOR -> REF_POINT_NO SYM_IDENTIFIER VAR_OR_FUN  {  $1 ($3 $2)  }
FACTOR -> SYM_LPARENTHESIS EXPR SYM_RPARENTHESIS {  $2  }


REF_POINT_NO -> {  fun x -> x  }
REF_POINT_NO -> SYM_ASTERISK POINTER_NO {  fun x -> $2 (Node(Tptr,[x]))}
REF_POINT_NO -> SYM_AMPERSAND {  fun x -> (Node(Tamp,[x]))}


VAR_OR_FUN -> SYM_LPARENTHESIS LEXPRS SYM_RPARENTHESIS  {  fun x -> Node(Tcall,[Node(Tfunname,[StringLeaf(x)]);Node(Targs,$2)])  }
VAR_OR_FUN ->  {  fun x -> StringLeaf(x)  }

EQ_EXPRS -> SYM_EQUALITY EQ_EXPR EQ_EXPRS {  Node(Tceq,[$2])::$3  }
EQ_EXPRS -> SYM_NOTEQ EQ_EXPR EQ_EXPRS {  Node(Tne,[$2])::$3  }
EQ_EXPRS -> {  []  }

CMP_EXPRS -> SYM_GEQ CMP_EXPR CMP_EXPRS {  Node(Tcge,[$2])::$3  }
CMP_EXPRS -> SYM_LEQ CMP_EXPR CMP_EXPRS {  Node(Tcle,[$2])::$3  }
CMP_EXPRS -> SYM_GT CMP_EXPR CMP_EXPRS {  Node(Tcgt,[$2])::$3  }
CMP_EXPRS -> SYM_LT CMP_EXPR CMP_EXPRS {  Node(Tclt,[$2])::$3  }
CMP_EXPRS -> {  []  }

ADD_EXPRS -> SYM_PLUS ADD_EXPR ADD_EXPRS {  Node(Tadd,[$2])::$3  }
ADD_EXPRS -> SYM_MINUS ADD_EXPR ADD_EXPRS {  Node(Tsub,[$2])::$3  }
ADD_EXPRS -> {  []  }

MUL_EXPRS -> SYM_ASTERISK MUL_EXPR MUL_EXPRS {  Node(Tmul,[$2])::$3  }
MUL_EXPRS -> SYM_DIV MUL_EXPR MUL_EXPRS {  Node(Tdiv,[$2])::$3  }
MUL_EXPRS -> SYM_MOD MUL_EXPR MUL_EXPRS {  Node(Tmod,[$2])::$3  }
MUL_EXPRS -> {  []  }

