open Batteries
open BatList
open Rtl
open Prog
open Utils

type linear_fun = {
  linearfunargs: rtl_arg list;
  linearfunbody: rtl_instr list;
  linearfuninfo: (string*reg) list;
  linearfunstksz : int
}

let list_reg_of_funargs (f : linear_fun) : reg list =
  let l =List.fold_left (fun acc linear_arg ->
    match linear_arg with
    |Reg(r) -> r::acc
    |_ -> acc) [] f.linearfunargs
  in List.rev l
